# -*- coding: utf-8 -*-
import urllib

from pmxbot.core import command

from . import wolframalpha

@command("wolframalpha", aliases=('wa',), doc="Wolfram Alpha rules")
def wa(client, event, channel, nick, rest):
	query = wolframalpha.WolframAlpha(rest)
	res = query.results
	resd = dict([(p.title, '    '.join(p.result_raw.split('\\n')))
		for p in res])
	out = ['http://wolframalpha.com/input?%s %s Result pods.' % (
		urllib.urlencode({'i': rest}), len(res))]
	if 'Input' in resd:
		out.append('Input:')
		out.append(resd.pop('Input'))
	if 'Input interpretation' in resd:
		out.append('Input:')
		out.append(resd.pop('Input interpretation'))
	if 'Result' in resd:
		out.append('Result:')
		out.append(resd.pop('Result'))
	yield ' '.join(out)
	for title, result in resd.iteritems():
		yield '%s: %s' % (title, result)
